﻿using System;

namespace Ruru.Game
{
    public class BaseBallGame
    {
        /// <summary>
        /// 투수가 던질 수
        /// </summary>
        private Pitcher pit;
        /// <summary>
        /// 타자가 입력한 수
        /// </summary>
        private Hitter hit;
        /// <summary>
        /// 심판
        /// </summary>
        private Referee refer;

        /// <summary>
        /// 게임에 사용할 숫자 범위
        /// </summary>
        private int range;
        /// <summary>
        /// 게임에 한번에 입력할 갯수
        /// </summary>
        private int num;

        public BaseBallGame()
            :this(10, 3)
        {
        }

        public BaseBallGame(int range, int num)
        {
            this.range = range;
            this.num = num;
        }

        ~BaseBallGame()
        {
        }

        public void PlayGame()
        {
            bool wins = false;
            int count = 0;

            pit = new Pitcher(this.range, this.num);
            hit = new Hitter(this.range, this.num);
            refer = new Referee();

            pit.Make();//투수가 공을 던진다.
            refer.Pit = pit.Ball;
            //BaseUtil.Print(pit.Ball);

            while (count != 10)
            {
                count++;
                hit.ReMake();//타자가 친다.
                refer.Hit = hit.Ball;

                Console.WriteLine("{0} 번째 배팅", count);
                Console.WriteLine("{0} 스트라이크, {1} 볼"
                    , refer.Strike(), refer.Ball());

                if (refer.Strike() == this.num)
                {
                    wins = true;
                    break;
                }
            }

            if (wins)
            {
                Console.WriteLine("You Win!! You Try {0} times", count);
                Console.Write("Pitcher "); BaseUtil.Print(pit.Ball);
                Console.Write("Hitter "); BaseUtil.Print(hit.Ball);
            }
            else
            {
                Console.WriteLine("You Lose, Like YoungXXX");
                Console.Write("Pitcher "); BaseUtil.Print(pit.Ball);
                Console.Write("Hitter "); BaseUtil.Print(hit.Ball);
            }
        }
    }
}
